#include "GXAlign.h"

int GXMemPool::kMinSpace = 1000000;

#ifdef GDEBUG
 char buf[6]={0x1B,'[', 'n','m','m','\0'};

void color_fg(int c,FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"%dm",c+30);
 fwrite(buf,1,strlen(buf), f);
}

void color_bg(int c, FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"%dm",c+40);
 fwrite(buf,1,strlen(buf),f);
};

void color_resetfg(FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"39m");
 fwrite(buf,1,strlen(buf), f);
};

void color_resetbg(FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"49m");
 fwrite(buf,1,strlen(buf), f);
}

void color_reset(FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"0m");
 fwrite(buf,1,strlen(buf), f);
};

void color_normal(FILE* f) {
 if (f!=stderr && f!=stdout) return;
 sprintf((char *)(&buf[2]),"22m");
 fwrite(buf,1,strlen(buf), f);
};

#endif


char xgapcodes[4]={'S','I', 'D', 'X'};

int get_last(int **flast_d, int d, int diag, int *row1) {
  if (flast_d[d-1][diag-1] > GMAX(flast_d[d-1][diag], flast_d[d-1][diag+1])) {
      *row1 = flast_d[d-1][diag-1];
      return diag-1;
      } 
  if (flast_d[d-1][diag] > flast_d[d-1][diag+1]) {
      *row1 = flast_d[d-1][diag];
      return diag;
      }
  *row1 = flast_d[d-1][diag+1];
  return diag+1;
}

void GapXEditScript::print() { //debug
      GapXEditScript* p=this;
      do {
        GMessage("%d%c ",p->num, xgapcodes[p->op_type]); 
        } while ((p=p->next)!=NULL); 
      GMessage("\n");
    }


int BLAST_Gcd(int a, int b) {
   int   c;

   b = abs(b);
   if (b > a)
      c=a, a=b, b=c;

   while (b != 0) {
      c = a%b;
      a = b;
      b = c;
   }
   return a;
}

int BLAST_Gdb3(int* a, int* b, int* c) {
    int g;
    if (*b == 0)
        g = BLAST_Gcd(*a, *c);
    else
        g = BLAST_Gcd(*a, BLAST_Gcd(*b, *c));
    if (g > 1) {
        *a /= g;
        *b /= g;
        *c /= g;
    }
    return g;
}



//signal that a diagonal is invalid
static const int kInvalidOffset = -2;

int s_FindFirstMismatch(const char *seq1, int len1,
                        const char *seq2, int len2,
                           int seq1_index, int seq2_index,
                              //bool &fence_hit,
                               bool reverse) {
    int start_index = seq1_index;
    /* Sentry detection here should be relatively inexpensive: The
       sentry value cannot appear in the query, so detection only
       needs to be done at exit from the subject-query matching loop.
       For uncompressed sequences, ambiguities in the query (i.e. seq1)
       always count as mismatches */
    if (reverse) {
              while (seq1_index < len1 && seq2_index < len2 &&
                     //seq1[len1-1 - seq1_index] < 4 &&
                       seq1[len1-1 - seq1_index] == seq2[len2-1 - seq2_index]) {
                    ++seq1_index;
                    ++seq2_index;
                    }
            //if (seq2_index < len2 && seq2[len2-1-seq2_index] == FENCE_SENTRY) {
              //if len2-1-seq2_index<=0) {
              //   fence_hit = true;
             //    }
      }
    else { //forward lookup
             while (seq1_index < len1 && seq2_index < len2 && 
                   //seq1[seq1_index] < 4 &&
                   seq1[seq1_index] == seq2[seq2_index]) {
                ++seq1_index;
                ++seq2_index;
                }
            //if (seq2_index < len2 && seq2[seq2_index] == FENCE_SENTRY) {
             //if (seq2_index==len2) {
             //   fence_hit = true;
            //}
    }
    return seq1_index - start_index;
}



/** During the traceback for a non-affine greedy alignment,
    compute the diagonal that will result from the next
    traceback operation

    @param last_seq2_off Array of offsets into the second sequence;
                        last_seq2_off[d][k] gives the largest offset into
                        the second sequence that lies on diagonal k and
                        has distance d [in]
    @param d Starting distance [in]
    @param diag Index of diagonal that produced the starting distance [in]
    @param seq2_index The offset into the second sequence after the traceback
                operation has completed [out]
    @return The diagonal resulting from the next traceback operation
                being applied
*/
int s_GetNextNonAffineTback(int **last_seq2_off, int d,
                        int diag, int *seq2_index) {
    // choose the traceback operation that results in the
    //   largest seq2 offset at this point, then compute the
    //   new diagonal that is implied by the operation
    if (last_seq2_off[d-1][diag-1] >
                GMAX(last_seq2_off[d-1][diag], last_seq2_off[d-1][diag+1])) {
        *seq2_index = last_seq2_off[d-1][diag-1];
        return diag - 1;    // gap in seq2
    }
    if (last_seq2_off[d-1][diag] > last_seq2_off[d-1][diag+1]) {
        *seq2_index = last_seq2_off[d-1][diag];
        return diag;        // match
    }
    *seq2_index = last_seq2_off[d-1][diag+1];
    return diag + 1;        // gap in seq1
}


int GXGreedyExtend(const char* seq1, int len1,
                       const char* seq2, int len2,
                       bool reverse, int xdrop_threshold,
                       int match_cost, int mismatch_cost,
                       int& seq1_align_len, int& seq2_align_len,
                       SGreedyAlignMem& aux_data,
                       GXEditScript *edit_block) {
                       //GapPrelimEditBlock *edit_block,
                       //bool& fence_hit, SGreedySeed *seed) {
  int seq1_index;
    int seq2_index;
    int index;
    int d;
    int k;
    int diag_lower, diag_upper;
    int max_dist;
    int diag_origin;
    int best_dist;
    int best_diag;
    int** last_seq2_off;
    int* max_score;
    int xdrop_offset;
    int longest_match_run;
    bool end1_reached, end2_reached;
    GXMemPool* mem_pool;
 
    /* ordinary dynamic programming alignment, for each offset
       in seq1, walks through offsets in seq2 until an X-dropoff
       test fails, saving the best score encountered along 
       the way. Instead of score, this code tracks the 'distance'
       (number of mismatches plus number of gaps) between seq1
       and seq2. Instead of walking through sequence offsets, it
       walks through diagonals that can achieve a given distance.
     
       Note that in what follows, the numbering of diagonals implies
       a dot matrix where increasing seq1 offsets go to the right on 
       the x axis, and increasing seq2 offsets go up the y axis.
       The gapped alignment thus proceeds up and to the right in
       the graph, and diagonals are numbered increasing to the right */

    best_dist = 0;
    best_diag = 0;

    /* set the number of distinct distances the algorithm will
       examine in the search for an optimal alignment. The 
       heuristic worst-case running time of the algorithm is 
       O(max_dist**2 + (len1+len2)); for sequences which are
       very similar, the average running time will be sig-
       nificantly better than this */

    max_dist = GMIN(GREEDY_MAX_COST,
                   len2 / GREEDY_MAX_COST_FRACTION + 1);

    /* the main loop assumes that the index of all diagonals is
       biased to lie in the middle of allocated bookkeeping 
       structures */

    diag_origin = max_dist + 2;

    // last_seq2_off[d][k] is the largest offset into seq2 that
    //   lies on diagonal k and has distance d

    last_seq2_off = aux_data.last_seq2_off;

    /* Instead of tracking the best alignment score and using
       xdrop_theshold directly, track the best score for each
       unique distance and use the best score for some previously
       computed distance to implement the X-dropoff test.

       xdrop_offset gives the distance backwards in the score
       array to look */

    xdrop_offset = (xdrop_threshold + match_cost / 2) / 
                           (match_cost + mismatch_cost) + 1;
    
    // find the offset of the first mismatch between seq1 and seq2

    index = s_FindFirstMismatch(seq1, len1,  seq2, len2, 0, 0, reverse);
                               // fence_hit, reverse, rem);

    // update the extents of the alignment, and bail out
    //   early if no further work is needed

    seq1_align_len = index;
    seq2_align_len = index;
    seq1_index = index;
    /*
    seed->start_q = 0;
    seed->start_s = 0;
    seed->match_length = index;
    */
    longest_match_run = index;

    if (index == len1 || index == len2) {
        /* Return the number of differences, which is zero here */
        if (edit_block != NULL)
            //GapPrelimEditBlockAdd(edit_block, eGapAlignSub, index);
            edit_block->opRep(index);
        return 0; 
    }

    // set up the memory pool
    mem_pool = aux_data.space;
    if (edit_block == NULL) {
       mem_pool = NULL;
      }
    else if (mem_pool == NULL) {
       aux_data.space = mem_pool = new GXMemPool();
    } 
    else {
        mem_pool->refresh();
    }
    
    /* set up the array of per-distance maximum scores. There
       are max_diags + xdrop_offset distances to track, the first
       xdrop_offset of which are 0 */

    max_score = aux_data.max_score + xdrop_offset;
    for (index = 0; index < xdrop_offset; index++)
        aux_data.max_score[index] = 0;
    
    // fill in the initial offsets of the distance matrix

    last_seq2_off[0][diag_origin] = seq1_index;
    max_score[0] = seq1_index * match_cost;
    diag_lower = diag_origin - 1;
    diag_upper = diag_origin + 1;
    end1_reached = end2_reached = false;

    // for each distance
    for (d = 1; d <= max_dist; d++) {
        int xdrop_score;
        int curr_score;
        int curr_extent = 0;
        int curr_seq2_index = 0;
        int curr_diag = 0;
        int tmp_diag_lower = diag_lower;
        int tmp_diag_upper = diag_upper;

        // Assign impossible seq2 offsets to any diagonals that
        // are not in the range (diag_lower,diag_upper).
        // These will serve as sentinel values for the inner loop
        last_seq2_off[d - 1][diag_lower-1] = kInvalidOffset;
        last_seq2_off[d - 1][diag_lower] = kInvalidOffset;
        last_seq2_off[d - 1][diag_upper] = kInvalidOffset;
        last_seq2_off[d - 1][diag_upper+1] = kInvalidOffset;

        // compute the score for distance d corresponding to the X-dropoff criterion

        xdrop_score = max_score[d - xdrop_offset] + 
                      (match_cost + mismatch_cost) * d - xdrop_threshold;
        xdrop_score = (int)ceil((double)xdrop_score / (match_cost / 2)); 

        // for each diagonal of interest
        for (k = tmp_diag_lower; k <= tmp_diag_upper; k++) {
            /* find the largest offset into seq2 that increases
               the distance from d-1 to d (i.e. keeps the alignment
               from getting worse for as long as possible), then 
               choose the offset into seq1 that will keep the
               resulting diagonal fixed at k 
             
               Note that this requires kInvalidOffset+1 to be smaller
               than any valid offset into seq2, i.e. to be negative */

            seq2_index = GMAX(last_seq2_off[d - 1][k + 1],
                              last_seq2_off[d - 1][k    ]) + 1;
            seq2_index = GMAX(seq2_index, last_seq2_off[d - 1][k - 1]);
            seq1_index = seq2_index + k - diag_origin;

            if (seq2_index < 0 || seq1_index + seq2_index < xdrop_score) {

                // if no valid diagonal can reach distance d, or the
                //   X-dropoff test fails, narrow the range of diagonals
                //   to test and skip to the next diagonal
                if (k == diag_lower)
                    diag_lower++;
                else
                    last_seq2_off[d][k] = kInvalidOffset;
                continue;
            }
            diag_upper = k;
            
            /* slide down diagonal k until a mismatch 
               occurs. As long as only matches are encountered,
               the current distance d will not change */

            index = s_FindFirstMismatch(seq1, len1, seq2, len2,
                                        seq1_index, seq2_index, reverse);
                                        //fence_hit, reverse, rem);
            if (index > longest_match_run) {
                //seed->start_q = seq1_index;
                //seed->start_s = seq2_index;
                //seed->match_length = index;
                longest_match_run = index;
                }
            seq1_index += index;
            seq2_index += index;

            // set the new largest seq2 offset that achieves
            //   distance d on diagonal k

            last_seq2_off[d][k] = seq2_index;

            // since all values of k are constrained to have the
            // same distance d, the value of k which maximizes the
            // alignment score is the one that covers the most of seq1 and seq2
            if (seq1_index + seq2_index > curr_extent) {
                curr_extent = seq1_index + seq2_index;
                curr_seq2_index = seq2_index;
                curr_diag = k;
               }

            /* clamp the bounds on diagonals to avoid walking off
               either sequence. Because the bounds increase by at
               most one for each distance, diag_lower and diag_upper
               can each be of size at most max_diags+2 */

            if (seq2_index == len2) {
                diag_lower = k + 1; 
                end2_reached = true;
            }
            if (seq1_index == len1) {
                diag_upper = k - 1; 
                end1_reached = true;
            }
        }  // end loop over diagonals

        // compute the maximum score possible for distance d
        curr_score = curr_extent * (match_cost / 2) - 
                        d * (match_cost + mismatch_cost);
        // if this is the best score seen so far, update the
        // statistics of the best alignment
        if (curr_score > max_score[d - 1]) {
            max_score[d] = curr_score;
            best_dist = d;
            best_diag = curr_diag;
            seq2_align_len = curr_seq2_index;
            seq1_align_len = curr_seq2_index + best_diag - diag_origin;
        } 
        else {
            max_score[d] = max_score[d - 1];
        }

        // alignment has finished if the lower and upper bounds
        //   on diagonals to check have converged to each other

        if (diag_lower > diag_upper)
            break;

        /* set up for the next distance to examine. Because the 
           bounds increase by at most one for each distance, 
           diag_lower and diag_upper can each be of size at 
           most max_diags+2 */

        if (!end2_reached)
            diag_lower--; 
        if (!end1_reached)
            diag_upper++;

        if (edit_block == NULL) {
           // if no traceback is specified, the next row of
           //   last_seq2_off can reuse previously allocated memory
           //TODO FIXME The following assumes two arrays of
           //  at least max_dist+4 int's have already been allocated
            last_seq2_off[d + 1] = last_seq2_off[d - 1];
            }
        else {
            // traceback requires all rows of last_seq2_off to be saved,
            // so a new row must be allocated
            last_seq2_off[d + 1] = (int*)mem_pool->getByteSpace((diag_upper - diag_lower + 7)*sizeof(int));
            // move the origin for this row backwards
            //TODO FIXME: dubious pointer arithmetic ?!
            //last_seq2_off[d + 1] = last_seq2_off[d + 1] - diag_lower + 2;
            }
    }   // end loop over distinct distances

    
    if (edit_block == NULL)
        return best_dist;

    //----  perform traceback
    d = best_dist; 
    seq1_index = seq1_align_len;
    seq2_index = seq2_align_len;
    // for all positive distances

    //if (fence_hit && *fence_hit)
    //    goto done;
    if (index==len1 || index==len2) d=0;
    while (d > 0) {
        int new_diag;
        int new_seq2_index;

        /* retrieve the value of the diagonal after the next
           traceback operation. best_diag starts off with the
           value computed during the alignment process */

        new_diag = s_GetNextNonAffineTback(last_seq2_off, d, 
                                           best_diag, &new_seq2_index);

        if (new_diag == best_diag) {
            // same diagonal: issue a group of substitutions
            if (seq2_index - new_seq2_index > 0) {
                  edit_block->opRep(seq2_index - new_seq2_index);
            }
        } 
        else if (new_diag < best_diag) {
            // smaller diagonal: issue a group of substitutions
            //   and then a gap in seq2 */
            if (seq2_index - new_seq2_index > 0) {
              edit_block->opRep(seq2_index - new_seq2_index);
            }
            //GapPrelimEditBlockAdd(edit_block, eGapAlignIns, 1);
            edit_block->opIns(1);
        } 
        else {
            // larger diagonal: issue a group of substitutions
            //   and then a gap in seq1
            if (seq2_index - new_seq2_index - 1 > 0) {
                edit_block->opRep(seq2_index - new_seq2_index - 1);
            }
            edit_block->opDel(1);
        }
        d--; 
        best_diag = new_diag; 
        seq2_index = new_seq2_index; 
    }
//done:
    // handle the final group of substitutions back to distance zero,
    //   i.e. back to offset zero of seq1 and seq2
    //GapPrelimEditBlockAdd(edit_block, eGapAlignSub,
    //                      last_seq2_off[0][diag_origin]);
    edit_block->opRep(last_seq2_off[0][diag_origin]);
    if (!reverse)
      edit_block->reverse();
    return best_dist;
}

void printEditScript(GXEditScript* ed_script) {
   uint i;
   if (ed_script==NULL || ed_script->opnum == 0)
      return;
   for (i=0; i<ed_script->opnum; i++) {
      int num=((ed_script->ops[i]) >> 2);
      unsigned char op_type = 3 - ( ed_script->ops[i] & EDIT_OP_MASK );
      if (op_type == 3)
         GError("Error: printEditScript encountered op_type 3 ?!\n");
      GMessage("%d%c ", num, xgapcodes[op_type]); 
      }
    GMessage("\n");
  }

GXAlnInfo* GreedyAlign(const char* q_seq,  int q_alnstart, const char* s_seq, int s_alnstart,
        bool editscript, int reward, int penalty, int xdrop) {
 int q_max=strlen(q_seq); //query
 int s_max=strlen(s_seq); //subj
 return GreedyAlignRegion(q_seq, q_alnstart, q_max,
          s_seq,  s_alnstart, s_max, galn_NoTrim, editscript, NULL, reward, penalty, xdrop);
}

struct GXSeedTable {
  int a_num, b_num;
  int a_cap, b_cap;
  char* xc;
  GXSeedTable(int a=12, int b=255) {
    a_cap=0;
    b_cap=0;
    a_num=0;
    b_num=0;
    xc=NULL;
    init(a,b);
    }
  ~GXSeedTable() {
     GFREE(xc);
     }
  void init(int a, int b) {
    a_num=a;
    b_num=b;
    bool resize=false;
    if (b_num>b_cap) { resize=true; b_cap=b_num;}
    if (a_num>a_cap) { resize=true; a_cap=a_num;}
    if (resize) {
      GFREE(xc);
      GCALLOC(xc, (a_num*b_num));
      }
     else {
      //just clear up to a_max, b_max
      memset((void*)xc, 0, (a_num*b_num));
      }
    }
   char& x(int ax, int by) {
       return xc[by*a_num+ax];
       }

};


GXBandSet* collectSeeds_R(GList<GXSeed>& seeds, const char* seqa, int a_len, const char* seqb, int b_len) {
 //overlap of right (3') end of seqb
 //hash the first 12 bases of seqa:
 int aimin=0;
 int aimax=GMIN(9,(a_len-4));
 int bimin=GMAX(0,(b_len-a_len-2));//allow 2 extraneous bases, just in case there is some garbage at the end
 int bimax=b_len-4;
 int a_maxlen=aimax+4; //number of rows in the diagonal matrix
 int b_maxlen=b_len; //number of cols in the diagonal matrix
 GXSeedTable gx(a_maxlen, b_maxlen);
 GXBandSet* diagstrips=new GXBandSet(a_maxlen, b_maxlen); //set of overlapping 3-diagonal strips
 for (int ai=aimin;ai<=aimax;ai++) {
    int32* av=(int32 *)(&seqa[ai]);
    //for (int bi=b_len-4;bi>=bimin;bi--) {
    for (int bi=bimin;bi<=bimax;bi++) {
       if (gx.x(ai,bi))
    	    continue; //already have a previous seed covering this region of this diagonal
       int32* bv=(int32 *)(&seqb[bi]);
       if (*av == *bv) {
          //word match
          //see if we can extend to the right
    	    gx.x(ai+1,bi+1)=1;
    	    gx.x(ai+2,bi+2)=1;
    	    gx.x(ai+3,bi+3)=1;
          int aix=ai+4;
          int bix=bi+4;
          int len=4;
          while (bix<b_maxlen && aix<a_maxlen && seqa[aix]==seqb[bix])
               {
                 gx.x(aix,bix)=1;
                 aix++;bix++;
                 len++;
               }
          GXSeed* newseed=new GXSeed(ai,bi,len);
          seeds.Add(newseed);
          diagstrips->addSeed(newseed);//add it to all 3 adjacent diagonals
          }
       }
    }//for each 4-mer at the beginning of seqa
 for (int i=0;i<diagstrips->Count();i++) {
    diagstrips->Get(i)->finalize(); //adjust scores due to overlaps or gaps between seeds
    }
 diagstrips->setSorted(true); //sort by score
 //diagstrips->setSorted(cmpDiagBands_R); //sort by score
 return diagstrips;
}

GXBandSet* collectSeeds_L(GList<GXSeed>& seeds, const char* seqa, int a_len, const char* seqb, int b_len) {
 //overlap of left (5') end of seqb
 //hash the last 12 bases of seqa:
 int aimin=GMAX(0,(a_len-16));
 int aimax=a_len-4;
 int bimin=0;
 int bimax=GMIN((a_len-2), (b_len-4));
 int a_maxlen=aimax+4; //number of rows in the diagonal matrix
 int b_maxlen=b_len; //number of cols in the diagonal matrix
 //gx.init(a_maxlen, b_maxlen);
 GXSeedTable gx(a_maxlen, b_maxlen);
 GXBandSet* diagstrips=new GXBandSet(a_maxlen, b_maxlen); //set of overlapping 3-diagonal strips
 for (int ai=aimin;ai<=aimax;ai++) {
    int32* av=(int32 *)(&seqa[ai]);
    for (int bi=bimin;bi<=bimax;bi++) {
       if (gx.x(ai,bi))
          continue; //already have a previous seed covering this region of this diagonal
       int32* bv=(int32 *)(&seqb[bi]);
       if (*av == *bv) {
          //word match
          //see if we can extend to the right
        gx.x(ai+1,bi+1)=1;
        gx.x(ai+2,bi+2)=1;
        gx.x(ai+3,bi+3)=1;
          int aix=ai+4;
          int bix=bi+4;
          int len=4;
          while (bix<b_maxlen && aix<a_maxlen && seqa[aix]==seqb[bix])
               {
                 gx.x(aix,bix)=1;
                 aix++;bix++;
                 len++;
               }
          GXSeed* newseed=new GXSeed(ai,bi,len);
          seeds.Add(newseed);
          diagstrips->addSeed(newseed);//add it to all 3 adjacent diagonals
          }
       }
    }//for each 4-mer at the end of seqa
 for (int i=0;i<diagstrips->Count();i++) {
    diagstrips->Get(i)->finalize(); //adjust scores due to overlaps or gaps between seeds
    }
 diagstrips->setSorted(true); //sort by score
 return diagstrips;
}



int cmpSeedScore(const pointer p1, const pointer p2) {
  //return (((GXSeed*)s2)->len-((GXSeed*)s1)->len);
  GXSeed* s1=(GXSeed*)p1;
  GXSeed* s2=(GXSeed*)p2;
  if (s1->len==s2->len) {
     return (s1->b_ofs-s2->b_ofs);
     }
  else return (s2->len-s1->len);
}

int cmpSeedDiag(const pointer p1, const pointer p2) {
  GXSeed* s1=(GXSeed*)p1;
  GXSeed* s2=(GXSeed*)p2;
  return ((s1->b_ofs-s1->a_ofs)-(s2->b_ofs-s2->a_ofs));
}

GXAlnInfo* GreedyAlignRegion(const char* q_seq, int q_alnstart, int q_max,
                       const char* s_seq, int s_alnstart, int s_max, GAlnTrimType trimtype,
                        bool editscript, SGreedyAlignMem* gxmem, int reward, int penalty, int xdrop) {
  GXEditScript* ed_script_fwd = NULL;
  GXEditScript* ed_script_rev = NULL;
  if ( q_alnstart>q_max || q_alnstart<1 || s_alnstart>s_max || s_alnstart<1 )
     GError("GreedyAlign() Error: invalid anchor coordinate.\n");
  q_alnstart--;
  s_alnstart--;
  if (q_seq==NULL || q_seq[0]==0 || s_seq==NULL || s_seq[0]==0)
    GError("GreedyAlign() Error: attempt to use an empty sequence string!\n");
  if (q_seq[q_alnstart]!=s_seq[s_alnstart])
    GError("GreedyAlign() Error: improper anchor (mismatch)!\n");
  int q_ext_l=0, q_ext_r=0, s_ext_l=0, s_ext_r=0;
  const char* q=q_seq+q_alnstart;
  int q_avail=q_max-q_alnstart;
  const char* s=s_seq+s_alnstart;
  int s_avail=s_max-s_alnstart;
  if (penalty<0) penalty=-penalty;
  int MIN_GREEDY_SCORE=5*reward; //minimum score for an alignment to be reported
  GXAlnInfo* alninfo=NULL;
  bool freeAlnMem=(gxmem==NULL);
  if (freeAlnMem) {
     gxmem=new SGreedyAlignMem(reward, penalty, xdrop);
     }
  else gxmem->reset();
  int retscore = 0;
  int numdiffs = 0;
  if (trimtype==galn_TrimLeft) {
    if (editscript)
       ed_script_rev=new GXEditScript();

    int numdiffs_l =  GXGreedyExtend(s_seq, s_alnstart, q_seq, q_alnstart, true, xdrop,
                   reward, penalty, s_ext_l, q_ext_l, *gxmem, ed_script_rev);
    //check this extension here and bail out if it's not a good extension
    if (s_alnstart+1-s_ext_l>3) {
      delete ed_script_rev;
      if (freeAlnMem) delete gxmem;
      return NULL;
      }

    if (editscript)
       ed_script_fwd=new GXEditScript();
    int numdiffs_r = GXGreedyExtend(s, s_avail, q, q_avail, false, xdrop,
                            reward, penalty, s_ext_r, q_ext_r, *gxmem, ed_script_fwd);
    numdiffs=numdiffs_r+numdiffs_l;
    //convert num diffs to actual score
    retscore = (q_ext_r + s_ext_r + q_ext_l + s_ext_l)*reward/2 - numdiffs*(reward-penalty);
    if (editscript)
       ed_script_rev->Append(ed_script_fwd); //combine the two extensions
    }
  else {
    if (editscript) {
       ed_script_fwd=new GXEditScript();
       }
    int numdiffs_r = GXGreedyExtend(s, s_avail, q, q_avail, false, xdrop,
                            reward, penalty, s_ext_r, q_ext_r, *gxmem, ed_script_fwd);
    //check extension here and bail out if not a good right extension
    //assuming s_max is really at the right end of s_seq
    if (trimtype==galn_TrimRight && s_alnstart+s_ext_r<s_max-2) {
      delete ed_script_fwd;
      if (freeAlnMem) delete gxmem;
      return NULL;
      }
    if (editscript)
       ed_script_rev=new GXEditScript();
    int numdiffs_l =  GXGreedyExtend(s_seq, s_alnstart, q_seq, q_alnstart, true, xdrop,
                   reward, penalty, s_ext_l, q_ext_l, *gxmem, ed_script_rev);
    //convert num diffs to actual score
    numdiffs=numdiffs_r+numdiffs_l;
    retscore = (q_ext_r + s_ext_r + q_ext_l + s_ext_l)*reward/2 - numdiffs*(reward-penalty);
    if (editscript)
       ed_script_rev->Append(ed_script_fwd); //combine the two extensions
  }

  if (retscore>=MIN_GREEDY_SCORE) {
    alninfo=new GXAlnInfo(q_seq, q_alnstart+1-q_ext_l,q_alnstart+q_ext_r, s_seq, s_alnstart+1-s_ext_l, s_alnstart+s_ext_r);
    int hsp_length = GMIN(q_ext_l+q_ext_r, s_ext_l+s_ext_r);
    alninfo->score=retscore;
    alninfo->pid = 100 * (1 - ((double) numdiffs) / hsp_length);
#ifdef GDEBUG
    if (ed_script_rev) {
       GMessage("Final Edit script ::: ");
       printEditScript(ed_script_rev);
       }
#endif
    alninfo->editscript=ed_script_rev;
    alninfo->gapinfo = new CAlnGapInfo(ed_script_rev, alninfo->ql-1, alninfo->sl-1);
    }
  else {
    if (freeAlnMem) delete gxmem;
    delete ed_script_rev;
    delete alninfo;
    alninfo=NULL;
    }
  delete ed_script_fwd;
  return alninfo;
 }
